 ;
 ;                    Bmath.asm  v.03.01
 ;                    ~~~~~~~~~~~~~~~~~~
 ;                   (math with Bittians)
 ;            copyright  2001 by dennis crombie
 ; 
 ;            OSI Certified Open Source Software
 ; 
 ;               (MASM32 assembly source code)
 ;                      dc@bmath.net
;==========================================================
.code

bMath       PROC              ;  initialize bMath
;----------------------------------------------------------
      LOCAL tmp :DWORD
;----------------------------------------------------------
      push  esi
      finit
      fstcw _cw
      or    _cw, 0c00h
      fldcw _cw
;----------------------------------------------------------
;            Init conversion factors
;----------------------------------------------------------
      fldpi
      fld   degc
      fdiv
      fstp  D2R               ;  factor for converting
                              ;    Degrees to Radians
      fld   degc
      fldpi
      fdiv
      fstp  R2D               ;  factor for converting
                              ;    Radians to Degrees
      fld   btnc
      fldpi
      fdiv
      fstp  R2B               ;  factor for converting
                              ;    Radians to Bittians
      fld   btnc
      fld   degc
      fdiv
      fstp  D2B               ;  factor for converting
                              ;    Degrees to Bittians
      fld   degc
      fld   btnc
      fdiv
      fstp  B2D               ;  factor for converting
                              ;    Bittians to Degrees
      fldpi
      fld   btnc
      fdiv                    ;  TOS = 1 Bittian in Radians
      fst   B2R               ;  factor for converting
                              ;    Bittians to Radians

;----------------------------------------------------------
;            Sin / Cos tables
;----------------------------------------------------------
      xor   esi, esi
      fldz
      fstp  tmp
@@:
      fld   tmp
      fmul  ST, ST(1)
      fsin
      fst   _bsin [esi]
      fsub  _bsin [esi-8]
      fstp  _bs [esi-8]
      fld1
      fadd  tmp
      fstp  tmp
      add   esi, 8
      cmp   esi, 10240
      jb    @B       
      fldz
      fsub  _bs
      fstp  _xtra
      fstp  _tmp1

;----------------------------------------------------------
;            Init Sqare Root tables
;----------------------------------------------------------
      fld1
      xor   esi, esi
@@:
      fst   _tmp1
      fsqrt
      fstp  _sqrt [esi]
      add   esi, 4
      fld   _tmp1
      fadd  sqc
      cmp   esi, 8192
      jb    @B
      
      fstp  _tmp1
      
;----------------------------------------------------------
      fld   TWO
      xor   esi, esi
@@:
      fst   _tmp1
      fsqrt
      fstp  _sqrt2 [esi]
      add   esi, 4
      fld   _tmp1
      fadd  sqd
      cmp   esi, 8192
      jb    @B
      fstp  _tmp1

;----------------------------------------------------------
      pop   esi
      ret
bMath       endp


