
 ;                    Bmath.inc  v.03.01
 ;                    ~~~~~~~~~~~~~~~~~~
 ;                   (math with Bittians)
 ;            copyright  2001 by dennis crombie
 ; 
 ;            OSI Certified Open Source Software
 ; 
 ;               (MASM32 assembly source code)
 ;                      dc@bmath.net
;==========================================================
bMath       PROTO             ;Initialize bMath
;----------------------------------------------------------
bSin        MACRO
      fist  _tmp1
      mov   edi, _tmp1
      fisub _tmp1             ;  TOS = signed fractional
      rol   edi, 4            ;  now edi is the adjusted 
      and   edi, 8            ;   sign index (0 or 8)
      mov   esi, _tmp1
      and   esi, 03ffh
      rol   esi, 3
      sub   esi, edi
      fmul  _bs [esi]
      add   esi, edi
      fadd  _bsin [esi]       ;  Sin(BittiansIn) in TOS
ENDM

;----------------------------------------------------------
bCos        MACRO
      fist  _tmp1
      mov   edi, _tmp1
      fisub _tmp1
      rol   edi, 4
      and   edi, 8
      mov   esi, _tmp1
      and   esi, 03ffh
      rol   esi, 3
      sub   esi, edi
      fmul  _bc [esi]
      add   esi, edi
      fadd  _bcos [esi]
ENDM

;----------------------------------------------------------
rSin        MACRO
      fmul  R2B               ;  convert to Bittians
      bSin                    ;  use bFn
ENDM

;----------------------------------------------------------
rCos        MACRO
      fmul  R2B
      bCos
ENDM

;----------------------------------------------------------
dSin        MACRO
      fmul  D2B
      bSin
ENDM

;----------------------------------------------------------
dCos        MACRO
      fmul  D2B
      bCos
ENDM

;----------------------------------------------------------
bCS         MACRO
      fist  _tmp1
      mov   edi, _tmp1
      fisub _tmp1             ;  TOS = signed fractional
      fst   _tmp2
      rol   edi, 4            ;  now edi is the adjusted 
      and   edi, 8            ;   sign index (0 or 8)
      mov   esi, _tmp1
      and   esi, 03ffh
      rol   esi, 3
      add   esi, edi          ;  got index
      fmul  _bs [esi]
      sub   esi, edi
      fadd  _bsin [esi]       ;  Sin(BittiansIn) in TOS
      fld   _tmp2
      fmul  _bc [esi]
      sub   esi, edi
      fadd  _bcos [esi]       ;  Cos(BittiansIn) in TOS
ENDM                          ;  Sin(BittiansIn) in ST(1)

;----------------------------------------------------------
bSC         MACRO
      fist  _tmp1
      mov   edi, _tmp1
      fisub _tmp1
      fst   _tmp2
      rol   edi, 4
      and   edi, 8
      mov   esi, _tmp1
      and   esi, 03ffh
      rol   esi, 3
      add   esi, edi
      fmul  _bc [esi]
      sub   esi, edi
      fadd  _bcos [esi]
      fld   _tmp2
      fmul  _bs [esi]
      sub   esi, edi
      fadd  _bsin [esi]
ENDM

;----------------------------------------------------------
rCS         MACRO
      fmul  R2B               ;  convert to Bittians
      bCS                     ;  call bFn
ENDM

;----------------------------------------------------------
rSC         MACRO
      fmul  R2B
      bSC
ENDM

;----------------------------------------------------------
dCS         MACRO
      fmul  D2B
      bCS
ENDM

;----------------------------------------------------------
dSC         MACRO
      fmul  D2B
      bSC
ENDM

;----------------------------------------------------------
bSnapS      MACRO
      fadd  HALF
      fistp _tmp1
      mov   esi, _tmp1
      and   esi, 03ffh
      rol   esi, 3
      fld   _bsin [esi]
ENDM

;----------------------------------------------------------
dSnapS      MACRO
      fmul  D2B
      bSnapS
ENDM

;----------------------------------------------------------
rSnapS      MACRO
      fmul  R2B
      bSnapS
ENDM

;----------------------------------------------------------
bSnapC      MACRO
      fadd  HALF
      fistp _tmp1
      mov   esi, _tmp1
      and   esi, 03ffh
      rol   esi, 3
      fld   _bcos [esi]
ENDM

;----------------------------------------------------------
dSnapC      MACRO
      fmul  D2B
      bSnapC
ENDM

;----------------------------------------------------------
rSnapC      MACRO
      fmul  R2B
      bSnapC
ENDM

;----------------------------------------------------------
bSnapSC     MACRO
      bSnapC
      fld   _bsin [esi]
ENDM

;----------------------------------------------------------
dSnapSC     MACRO
      fmul  D2B
      bSnapSC
ENDM

;----------------------------------------------------------
rSnapSC     MACRO
      fmul  R2B
      bSnapSC
ENDM

;----------------------------------------------------------
bSnapCS     MACRO
      bSnapS
      fld   _bcos [esi]
ENDM

;----------------------------------------------------------
dSnapCS     MACRO
      fmul  D2B
      bSnapCS
ENDM

;----------------------------------------------------------
rSnapCS     MACRO
      fmul  R2B
      bSnapCS
ENDM

;==========================================================
;            Epilog/Prolog
;==========================================================
rSinS       MACRO
      push  esi
      rSin
      pop   esi
ENDM

;----------------------------------------------------------
rSinD       MACRO
      push  edi
      rSin
      pop   edi
ENDM

;----------------------------------------------------------
rSinB       MACRO
      push  esi
      push  edi
      rSin
      pop   edi
      pop   esi
ENDM

;----------------------------------------------------------
rCosS       MACRO
      push  esi
      rCos
      pop   esi
ENDM

;----------------------------------------------------------
rCosD       MACRO
      push  edi
      rCos
      pop   edi
ENDM

;----------------------------------------------------------
rCosB       MACRO
      push  esi
      push  edi
      rCos
      pop   edi
      pop   esi
ENDM

;----------------------------------------------------------
dSinS       MACRO
      push  esi
      dSin
      pop   esi
ENDM

;----------------------------------------------------------
dSinD       MACRO
      push  edi
      dSin
      pop   edi
ENDM

;----------------------------------------------------------
dSinB       MACRO
      push  esi
      push  edi
      dSin
      pop   edi
      pop   esi
ENDM

;----------------------------------------------------------
dCosS       MACRO
      push  esi
      dCos
      pop   esi
ENDM

;----------------------------------------------------------
dCosD       MACRO
      push  edi
      dCos
      pop   edi
ENDM

;----------------------------------------------------------
dCosB       MACRO
      push  esi
      push  edi
      dCos
      pop   edi
      pop   esi
ENDM

;----------------------------------------------------------
bSinS       MACRO
      push  esi
      bSin
      pop   esi
ENDM

;----------------------------------------------------------
bSinD       MACRO
      push  edi
      bSin
      pop   edi
ENDM

;----------------------------------------------------------
bSinB       MACRO
      push  esi
      push  edi
      bSin
      pop   edi
      pop   esi
ENDM

;----------------------------------------------------------
bCosS       MACRO
      push  esi
      bCos
      pop   esi
ENDM

;----------------------------------------------------------
bCosD       MACRO
      push  edi
      bCos
      pop   edi
ENDM

;----------------------------------------------------------
bCosB       MACRO
      push  esi
      push  edi
      bCos
      pop   edi
      pop   esi
ENDM

;----------------------------------------------------------
bCSS        MACRO
      push  esi
      bCS
      pop   esi
ENDM

;----------------------------------------------------------
dCSS        MACRO
      push  esi
      dCS
      pop   esi
ENDM

;----------------------------------------------------------
rCSS        MACRO
      push  esi
      rCS
      pop   esi
ENDM

;----------------------------------------------------------
bSCS        MACRO
      push  esi
      bSC
      pop   esi
ENDM

;----------------------------------------------------------
dSCS        MACRO
      push  esi
      dSC
      pop   esi
ENDM

;----------------------------------------------------------
rSCS        MACRO
      push  esi
      rSC
      pop   esi
ENDM

;----------------------------------------------------------
bCSD        MACRO
      push  edi
      bCS
      pop   edi
ENDM

;----------------------------------------------------------
dCSD        MACRO
      push  edi
      dCS
      pop   edi
ENDM

;----------------------------------------------------------
rCSD        MACRO
      push  edi
      rCS
      pop   edi
ENDM

;----------------------------------------------------------
bSCD        MACRO
      push  edi
      bSC
      pop   edi
ENDM

;----------------------------------------------------------
dSCD        MACRO
      push  edi
      dSC
      pop   edi
ENDM

;----------------------------------------------------------
rSCD        MACRO
      push  edi
      rSC
      pop   edi
ENDM

;----------------------------------------------------------
bCSB        MACRO
      push  edi
      push  esi
      bCS
      pop   esi
      pop   edi
ENDM

;----------------------------------------------------------
dCSB        MACRO
      push  edi
      push  esi
      dCS
      pop   esi
      pop   edi
ENDM

;----------------------------------------------------------
rCSB        MACRO
      push  edi
      push  esi
      bCS
      pop   esi
      pop   edi
ENDM

;----------------------------------------------------------
bSCB        MACRO
      push  edi
      push  esi
      bSC
      pop   esi
      pop   edi
ENDM

;----------------------------------------------------------
dSCB        MACRO
      push  edi
      push  esi
      dSC
      pop   esi
      pop   edi
ENDM

;----------------------------------------------------------
rSCB        MACRO
      push  edi
      push  esi
      rSC
      pop   esi
      pop   edi
ENDM

;----------------------------------------------------------
bSnapSs     MACRO
      push  esi
      bSnapS
      pop   esi
ENDM

;----------------------------------------------------------
dSnapSs     MACRO
      push  esi
      dSnapS
      pop   esi
ENDM

;----------------------------------------------------------
rSnapSs     MACRO
      push  esi
      rSnapS
      pop   esi
ENDM

;----------------------------------------------------------
bSnapCs     MACRO
      push  esi
      bSnapC
      pop   esi
ENDM

;----------------------------------------------------------
dSnapCs     MACRO
      push  esi
      dSnapC
      pop   esi
ENDM

;----------------------------------------------------------
rSnapCs     MACRO
      push  esi
      rSnapC
      pop   esi
ENDM

;----------------------------------------------------------
bSnapSCs    MACRO
      push  esi
      bSnapSC
      pop   esi
ENDM

;----------------------------------------------------------
dSnapSCs    MACRO
      push  esi
      dSnapSC
      pop   esi
ENDM

;----------------------------------------------------------
rSnapSCs    MACRO
      push  esi
      rSnapSC
      pop   esi
ENDM

;----------------------------------------------------------
bSnapCSs    MACRO
      push  esi
      bSnapCS
      pop   esi
ENDM

;----------------------------------------------------------
dSnapCSs    MACRO
      push  esi
      dSnapCS
      pop   esi
ENDM

;----------------------------------------------------------
rSnapCSs    MACRO
      push  esi
      rSnapCS
      pop   esi
ENDM

;----------------------------------------------------------
;        Reduce fn's
;----------------------------------------------------------
bReduce     MACRO
      fist  BTN         ; 6
      fisub BTN         ; 7
      and   BTN, 03ffh  ; 3
      fiadd BTN         ; 7
ENDM
                        
;----------------------------------------------------------
rReduce     MACRO
      fmul  R2B
      bReduce
      fmul  B2R
ENDM

;----------------------------------------------------------
dReduce     MACRO
      fmul  D2B
      bReduce
      fmul  B2D
ENDM

;----------------------------------------------------------
;      get BTN fn's
;
;   NOTE: for possibly minus floating point angles
;   use the following code instead:
;
;     fmul  R2B   ; convert radians to bittians
;     bReduce
;     fistp  BTN
;
;   (Reduced Angles are Always Posotive)
;----------------------------------------------------------
bBTN        MACRO
      fist  BTN
      and   BTN, 03ffh
ENDM
;----------------------------------------------------------
bBTNp       MACRO
      fistp BTN
      and   BTN, 03ffh
ENDM
;----------------------------------------------------------
rBTN       MACRO
      fmul R2B
      bBTN
ENDM
;----------------------------------------------------------
rBTNp      MACRO
      fmul R2B
      bBTNp
ENDM
;----------------------------------------------------------
dBTN       MACRO
      fmul D2B
      bBTN
ENDM
;----------------------------------------------------------
dBTNp      MACRO
      fmul D2B
      bBTNp
ENDM
;----------------------------------------------------------
;        Sqare Root fn's
;----------------------------------------------------------
bSqrt      MACRO
      fst   _tmp1             ;  make it 32 bits
      mov   esi, _tmp1
      
      cmp   esi, 0            ;  zero?
      je    _zro
      fstp  _tmp2             ;  trash
      
      mov   esi, _tmp1
      and   esi, 07f800000h
      sub   esi, 03f800000h
      ror   esi, 1
      add   esi, 03f800000h
      and   esi, 07f800000h
      mov   _exp, esi         ;  exponent
      
      mov   esi, _tmp1
      and   esi, 0800000h
      cmp   esi, 0
      je    _odd              ;  exponent odd/even ?
      
      mov   esi, _tmp1
      and   esi, 07ff000h
      ror   esi, 9            ;  index ready
      
      fld  _sqrt [esi]
      fstp  _tmp2
      jmp   _okay
_odd:
      mov   esi, _tmp1
      and   esi, 07ff000h
      ror   esi, 9            ;  index ready
      fld  _sqrt2 [esi]
      fstp  _tmp2
_okay:
      mov   esi, _tmp2
      and   esi, 07fffffh
      or    esi, _exp
      mov   _tmp3, esi
      fld   _tmp3
_zro:
ENDM
;----------------------------------------------------------
.DATA

ZERO        dd      0.0
HALF        dd      0.5
ONE         dd      1.0
TWO         dd      2.0
FOUR        dd      4.0
btnc        dd      512.0
bytc        dd      128.0
degc        dd      180.0
sqc         dd      0.000244140625
sqd         dd      0.00048828125
Bittian     dd      6.13592315154256500e-0003
BTN         dd      00000000000000000000001111111111b
;----------------------------------------------------------
.data?

D2B         dq      ?
R2B         dq      ?
B2D         dq      ?
B2R         dq      ?
D2R         dq      ?
R2D         dq      ?
_cw         dw      ?
_exp        dd      ?
_frac       dd      ?
_odev       dd      ?
_tmp1       dd      ?
_tmp2       dd      ?
_tmp3       dd      ?
_bsin       dq      256 dup (?)
_bcos       dq      1024 dup (?)
_xtra       dq      ?
_bs         dq      256 dup (?)
_bc         dq      1024 dup (?)
_sqrt       dd      4096 dup (?)
_sqrt2      dd      4096 dup (?)

