
 ;                  Bmathecx.inc  v.03.01
 ;                  ~~~~~~~~~~~~~~~~~~~~~
 ;                   (math with Bittians)
 ;            copyright  2001 by dennis crombie
 ; 
 ;            OSI Certified Open Source Software
 ; 
 ;               (MASM32 assembly source code)
 ;                      dc@bmath.net
;==========================================================
bMath       PROTO             ;Initialize bMath
;----------------------------------------------------------
bSin        MACRO
      fist  _tmp1
      mov   edi, _tmp1
      fisub _tmp1             ;  TOS = signed fractional
      rol   edi, 4            ;  now edi is the adjusted 
      and   edi, 8            ;   sign index (0 or 8)
      mov   ecx, _tmp1
      and   ecx, 03ffh
      rol   ecx, 3
      sub   ecx, edi
      fmul  _bs [ecx]
      add   ecx, edi
      fadd  _bsin [ecx]       ;  Sin(BittiansIn) in TOS
ENDM

;----------------------------------------------------------
bCos        MACRO
      fist  _tmp1
      mov   edi, _tmp1
      fisub _tmp1
      rol   edi, 4
      and   edi, 8
      mov   ecx, _tmp1
      and   ecx, 03ffh
      rol   ecx, 3
      sub   ecx, edi
      fmul  _bc [ecx]
      add   ecx, edi
      fadd  _bcos [ecx]
ENDM

;----------------------------------------------------------
rSin        MACRO
      fmul  R2B               ;  convert to Bittians
      bSin                    ;  use bFn
ENDM

;----------------------------------------------------------
rCos        MACRO
      fmul  R2B
      bCos
ENDM

;----------------------------------------------------------
dSin        MACRO
      fmul  D2B
      bSin
ENDM

;----------------------------------------------------------
dCos        MACRO
      fmul  D2B
      bCos
ENDM

;----------------------------------------------------------
bCS         MACRO
      fist  _tmp1
      mov   edi, _tmp1
      fisub _tmp1             ;  TOS = signed fractional
      fst   _tmp2
      rol   edi, 4            ;  now edi is the adjusted 
      and   edi, 8            ;   sign index (0 or 8)
      mov   ecx, _tmp1
      and   ecx, 03ffh
      rol   ecx, 3
      add   ecx, edi          ;  got index
      fmul  _bs [ecx]
      sub   ecx, edi
      fadd  _bsin [ecx]       ;  Sin(BittiansIn) in TOS
      fld   _tmp2
      fmul  _bc [ecx]
      sub   ecx, edi
      fadd  _bcos [ecx]       ;  Cos(BittiansIn) in TOS
ENDM                          ;  Sin(BittiansIn) in ST(1)

;----------------------------------------------------------
bSC         MACRO
      fist  _tmp1
      mov   edi, _tmp1
      fisub _tmp1
      fst   _tmp2
      rol   edi, 4
      and   edi, 8
      mov   ecx, _tmp1
      and   ecx, 03ffh
      rol   ecx, 3
      add   ecx, edi
      fmul  _bc [ecx]
      sub   ecx, edi
      fadd  _bcos [ecx]
      fld   _tmp2
      fmul  _bs [ecx]
      sub   ecx, edi
      fadd  _bsin [ecx]
ENDM

;----------------------------------------------------------
rCS         MACRO
      fmul  R2B               ;  convert to Bittians
      bCS                     ;  call bFn
ENDM

;----------------------------------------------------------
rSC         MACRO
      fmul  R2B
      bSC
ENDM

;----------------------------------------------------------
dCS         MACRO
      fmul  D2B
      bCS
ENDM

;----------------------------------------------------------
dSC         MACRO
      fmul  D2B
      bSC
ENDM

;----------------------------------------------------------
bSnapS      MACRO
      fadd  HALF
      fistp _tmp1
      mov   ecx, _tmp1
      and   ecx, 03ffh
      rol   ecx, 3
      fld   _bsin [ecx]
ENDM

;----------------------------------------------------------
dSnapS      MACRO
      fmul  D2B
      bSnapS
ENDM

;----------------------------------------------------------
rSnapS      MACRO
      fmul  R2B
      bSnapS
ENDM

;----------------------------------------------------------
bSnapC      MACRO
      fadd  HALF
      fistp _tmp1
      mov   ecx, _tmp1
      and   ecx, 03ffh
      rol   ecx, 3
      fld   _bcos [ecx]
ENDM

;----------------------------------------------------------
dSnapC      MACRO
      fmul  D2B
      bSnapC
ENDM

;----------------------------------------------------------
rSnapC      MACRO
      fmul  R2B
      bSnapC
ENDM

;----------------------------------------------------------
bSnapSC     MACRO
      bSnapC
      fld   _bsin [ecx]
ENDM

;----------------------------------------------------------
dSnapSC     MACRO
      fmul  D2B
      bSnapSC
ENDM

;----------------------------------------------------------
rSnapSC     MACRO
      fmul  R2B
      bSnapSC
ENDM

;----------------------------------------------------------
bSnapCS     MACRO
      bSnapS
      fld   _bcos [ecx]
ENDM

;----------------------------------------------------------
dSnapCS     MACRO
      fmul  D2B
      bSnapCS
ENDM

;----------------------------------------------------------
rSnapCS     MACRO
      fmul  R2B
      bSnapCS
ENDM

;==========================================================
;            Epilog/Prolog
;==========================================================
rSinS       MACRO
      push  ecx
      rSin
      pop   ecx
ENDM

;----------------------------------------------------------
rSinD       MACRO
      push  edi
      rSin
      pop   edi
ENDM

;----------------------------------------------------------
rSinB       MACRO
      push  ecx
      push  edi
      rSin
      pop   edi
      pop   ecx
ENDM

;----------------------------------------------------------
rCosS       MACRO
      push  ecx
      rCos
      pop   ecx
ENDM

;----------------------------------------------------------
rCosD       MACRO
      push  edi
      rCos
      pop   edi
ENDM

;----------------------------------------------------------
rCosB       MACRO
      push  ecx
      push  edi
      rCos
      pop   edi
      pop   ecx
ENDM

;----------------------------------------------------------
dSinS       MACRO
      push  ecx
      dSin
      pop   ecx
ENDM

;----------------------------------------------------------
dSinD       MACRO
      push  edi
      dSin
      pop   edi
ENDM

;----------------------------------------------------------
dSinB       MACRO
      push  ecx
      push  edi
      dSin
      pop   edi
      pop   ecx
ENDM

;----------------------------------------------------------
dCosS       MACRO
      push  ecx
      dCos
      pop   ecx
ENDM

;----------------------------------------------------------
dCosD       MACRO
      push  edi
      dCos
      pop   edi
ENDM

;----------------------------------------------------------
dCosB       MACRO
      push  ecx
      push  edi
      dCos
      pop   edi
      pop   ecx
ENDM

;----------------------------------------------------------
bSinS       MACRO
      push  ecx
      bSin
      pop   ecx
ENDM

;----------------------------------------------------------
bSinD       MACRO
      push  edi
      bSin
      pop   edi
ENDM

;----------------------------------------------------------
bSinB       MACRO
      push  ecx
      push  edi
      bSin
      pop   edi
      pop   ecx
ENDM

;----------------------------------------------------------
bCosS       MACRO
      push  ecx
      bCos
      pop   ecx
ENDM

;----------------------------------------------------------
bCosD       MACRO
      push  edi
      bCos
      pop   edi
ENDM

;----------------------------------------------------------
bCosB       MACRO
      push  ecx
      push  edi
      bCos
      pop   edi
      pop   ecx
ENDM

;----------------------------------------------------------
bCSS        MACRO
      push  ecx
      bCS
      pop   ecx
ENDM

;----------------------------------------------------------
dCSS        MACRO
      push  ecx
      dCS
      pop   ecx
ENDM

;----------------------------------------------------------
rCSS        MACRO
      push  ecx
      rCS
      pop   ecx
ENDM

;----------------------------------------------------------
bSCS        MACRO
      push  ecx
      bSC
      pop   ecx
ENDM

;----------------------------------------------------------
dSCS        MACRO
      push  ecx
      dSC
      pop   ecx
ENDM

;----------------------------------------------------------
rSCS        MACRO
      push  ecx
      rSC
      pop   ecx
ENDM

;----------------------------------------------------------
bCSD        MACRO
      push  edi
      bCS
      pop   edi
ENDM

;----------------------------------------------------------
dCSD        MACRO
      push  edi
      dCS
      pop   edi
ENDM

;----------------------------------------------------------
rCSD        MACRO
      push  edi
      rCS
      pop   edi
ENDM

;----------------------------------------------------------
bSCD        MACRO
      push  edi
      bSC
      pop   edi
ENDM

;----------------------------------------------------------
dSCD        MACRO
      push  edi
      dSC
      pop   edi
ENDM

;----------------------------------------------------------
rSCD        MACRO
      push  edi
      rSC
      pop   edi
ENDM

;----------------------------------------------------------
bCSB        MACRO
      push  edi
      push  ecx
      bCS
      pop   ecx
      pop   edi
ENDM

;----------------------------------------------------------
dCSB        MACRO
      push  edi
      push  ecx
      dCS
      pop   ecx
      pop   edi
ENDM

;----------------------------------------------------------
rCSB        MACRO
      push  edi
      push  ecx
      bCS
      pop   ecx
      pop   edi
ENDM

;----------------------------------------------------------
bSCB        MACRO
      push  edi
      push  ecx
      bSC
      pop   ecx
      pop   edi
ENDM

;----------------------------------------------------------
dSCB        MACRO
      push  edi
      push  ecx
      dSC
      pop   ecx
      pop   edi
ENDM

;----------------------------------------------------------
rSCB        MACRO
      push  edi
      push  ecx
      rSC
      pop   ecx
      pop   edi
ENDM

;----------------------------------------------------------
bSnapSs     MACRO
      push  ecx
      bSnapS
      pop   ecx
ENDM

;----------------------------------------------------------
dSnapSs     MACRO
      push  ecx
      dSnapS
      pop   ecx
ENDM

;----------------------------------------------------------
rSnapSs     MACRO
      push  ecx
      rSnapS
      pop   ecx
ENDM

;----------------------------------------------------------
bSnapCs     MACRO
      push  ecx
      bSnapC
      pop   ecx
ENDM

;----------------------------------------------------------
dSnapCs     MACRO
      push  ecx
      dSnapC
      pop   ecx
ENDM

;----------------------------------------------------------
rSnapCs     MACRO
      push  ecx
      rSnapC
      pop   ecx
ENDM

;----------------------------------------------------------
bSnapSCs    MACRO
      push  ecx
      bSnapSC
      pop   ecx
ENDM

;----------------------------------------------------------
dSnapSCs    MACRO
      push  ecx
      dSnapSC
      pop   ecx
ENDM

;----------------------------------------------------------
rSnapSCs    MACRO
      push  ecx
      rSnapSC
      pop   ecx
ENDM

;----------------------------------------------------------
bSnapCSs    MACRO
      push  ecx
      bSnapCS
      pop   ecx
ENDM

;----------------------------------------------------------
dSnapCSs    MACRO
      push  ecx
      dSnapCS
      pop   ecx
ENDM

;----------------------------------------------------------
rSnapCSs    MACRO
      push  ecx
      rSnapCS
      pop   ecx
ENDM

;----------------------------------------------------------
;        Reduce fn's
;----------------------------------------------------------
bReduce     MACRO
      fist  BTN         ; 6
      fisub BTN         ; 7
      and   BTN, 03ffh  ; 3
      fiadd BTN         ; 7
ENDM
                        
;----------------------------------------------------------
rReduce     MACRO
      fmul  R2B
      bReduce
      fmul  B2R
ENDM

;----------------------------------------------------------
dReduce     MACRO
      fmul  D2B
      bReduce
      fmul  B2D
ENDM

;----------------------------------------------------------
;      get BTN fn's
;
;   NOTE: for possibly minus floating point angles
;   use the following code instead:
;
;     fmul  R2B   ; convert radians to bittians
;     bReduce
;     fistp  BTN
;
;   (Reduced Angles are Always Posotive)
;----------------------------------------------------------
bBTN        MACRO
      fist  BTN
      and   BTN, 03ffh
ENDM
;----------------------------------------------------------
bBTNp       MACRO
      fistp BTN
      and   BTN, 03ffh
ENDM
;----------------------------------------------------------
rBTN       MACRO
      fmul R2B
      bBTN
ENDM
;----------------------------------------------------------
rBTNp      MACRO
      fmul R2B
      bBTNp
ENDM
;----------------------------------------------------------
dBTN       MACRO
      fmul D2B
      bBTN
ENDM
;----------------------------------------------------------
dBTNp      MACRO
      fmul D2B
      bBTNp
ENDM
;----------------------------------------------------------
;        Sqare Root fn's
;----------------------------------------------------------
bSqrt      MACRO
      fst   _tmp1             ;  make it 32 bits
      mov   ecx, _tmp1
      
      cmp   ecx, 0            ;  zero?
      je    _zro
      fstp  _tmp2             ;  trash
      
      mov   ecx, _tmp1
      and   ecx, 07f800000h
      sub   ecx, 03f800000h
      ror   ecx, 1
      add   ecx, 03f800000h
      and   ecx, 07f800000h
      mov   _exp, ecx         ;  exponent
      
      mov   ecx, _tmp1
      and   ecx, 0800000h
      cmp   ecx, 0
      je    _odd              ;  exponent odd/even ?
      
      mov   ecx, _tmp1
      and   ecx, 07ff000h
      ror   ecx, 9            ;  index ready
      
      fld  _sqrt [ecx]
      fstp  _tmp2
      jmp   _okay
_odd:
      mov   ecx, _tmp1
      and   ecx, 07ff000h
      ror   ecx, 9            ;  index ready
      fld  _sqrt2 [ecx]
      fstp  _tmp2
_okay:
      mov   ecx, _tmp2
      and   ecx, 07fffffh
      or    ecx, _exp
      mov   _tmp3, ecx
      fld   _tmp3
_zro:
ENDM
;----------------------------------------------------------
bSqrtS      MACRO
      push  ecx
      bSqrt
      pop   ecx
ENDM
;----------------------------------------------------------

.DATA

ZERO        dd      0.0
HALF        dd      0.5
ONE         dd      1.0
TWO         dd      2.0
FOUR        dd      4.0
btnc        dd      512.0
bytc        dd      128.0
degc        dd      180.0
sqc         dd      0.00048828125
sqd         dd      0.0009765625
Bittian     dd      6.13592315154256500e-0003
BTN         dd      00000000000000000000001111111111b
;----------------------------------------------------------
.data?

D2B         dq      ?
R2B         dq      ?
B2D         dq      ?
B2R         dq      ?
D2R         dq      ?
R2D         dq      ?
_cw         dw      ?
_exp        dd      ?
_frac       dd      ?
_odev       dd      ?
_tmp1       dd      ?
_tmp2       dd      ?
_tmp3       dd      ?
_bsin       dq      256 dup (?)
_bcos       dq      1024 dup (?)
_xtra       dq      ?
_bs         dq      256 dup (?)
_bc         dq      1024 dup (?)
_sqrt       dd      2048 dup (?)
_sqrt2      dd      2048 dup (?)

